#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

"""

===================
build_surname_id.py
===================

DESCRIPTION
===========

generation de la partie "nom" de l'id


SEE ALSO
========

:ref:`surname_id.xsl`

EXAMPLES
========

cf. doctest

::

    python -v build_surname_id

TODO
====

EVOLUTIONS
==========

$Id$

$URL$

- fplod 20120409

  * work with fake data

- fplod 20120407

  * creation

"""

import string
import sys

def build_surname_id(surname):


    """
    >>> surname = []
    []
    >>> surname.append(' Tartempillion ')
    [' Tartempillion ']
    >>> surname.append('Tar tempillion ')
    [' Tartempillion ', 'Tar tempillion ']
    >>> surname.append("T\'ar tempillion ")
    [' Tartempillion ', 'Tar tempillion ', "T\'ar tempillion "]
    >>> surname_id = build_surname_id(surname)
    ['TARTEMPILLION','TARTEMPILLION','TARTEMPILLION']
    """

    if len(surname) == 0:
        print('eee : surname empty')
        sys.exit(-1)

    # convert to str
    surname_str = [str(item) for item in surname]
    for item in surname:
        print ('iii : item type %s : %s ' % (item, type(item)))

    # remove white space before and after
    surname_id = map(str.strip,surname_str)
    #print ('1 sans blan debut fin %s' % surname_id)
    #
    # upper
    surname_id = map(str.upper,surname_id)
    #print ('2 upper %s' % surname_id)
    #
    # remove white space inside
    surname_id_no_spaces = [x.replace(' ', '') for x in surname_id]
    #print ('3 sans blanc milieu %s' % surname_id_no_spaces)
    surname_id = surname_id_no_spaces
    #
    # remove punctuation
    for c in string.punctuation:
        surname_id_no_punctuation = [x.replace(c, '') for x in surname_id]
        #print ('4 sans %s avec replace string.punctuation %s' % (c, surname_id_no_punctuation))
        surname_id = surname_id_no_punctuation

    return surname_id

if __name__ == "__main__":
    import doctest
    doctest.testmod()
